import { IgrContourValueResolver } from "./igr-contour-value-resolver";
import { LinearContourValueResolver } from "./LinearContourValueResolver";
/**
 * ContourValueResolver class which resolves contour lines to be distributed at linear intervals from the data minimum to the data maximum.
*/
export class IgrLinearContourValueResolver extends IgrContourValueResolver {
    createImplementation() {
        return new LinearContourValueResolver();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets how many contour values to return.
    */
    get valueCount() {
        return this.i.valueCount;
    }
    set valueCount(v) {
        this.i.valueCount = +v;
    }
}
//# sourceMappingURL=igr-linear-contour-value-resolver.js.map
