import { UnknownValuePlotting_$type } from "igniteui-react-core";
import { IgrScatterBase } from "./igr-scatter-base";
import { ScatterLineSeries } from "./ScatterLineSeries";
import { ensureEnum } from "igniteui-react-core";
/**
 * Represents a IgxDataChartComponent scatter line series
*/
export class IgrScatterLineSeries extends IgrScatterBase {
    createImplementation() {
        return new ScatterLineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting() {
        return this.i.ox;
    }
    set unknownValuePlotting(v) {
        this.i.ox = ensureEnum(UnknownValuePlotting_$type, v);
    }
}
//# sourceMappingURL=igr-scatter-line-series.js.map
