import { IgrStyle } from "igniteui-react-core";
import { IgrShapeSeriesBase } from "./igr-shape-series-base";
import { ScatterPolylineSeries } from "./ScatterPolylineSeries";
/**
 * Series class used for displaying multiple polylines for datasources which contain multiple lists of points.
*/
export class IgrScatterPolylineSeries extends IgrShapeSeriesBase {
    createImplementation() {
        return new ScatterPolylineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * The default style to apply to all Shapes in the series.
    */
    get shapeStyle() {
        if (this.i.ng == null) {
            return null;
        }
        if (!this.i.ng.externalObject) {
            let e = new IgrStyle();
            e._implementation = this.i.ng;
            this.i.ng.externalObject = e;
        }
        return this.i.ng.externalObject;
    }
    set shapeStyle(v) {
        v == null ? this.i.ng = null : this.i.ng = v.i;
    }
}
//# sourceMappingURL=igr-scatter-polyline-series.js.map
