import * as tslib_1 from "tslib";
import { IgrItemwiseStrategyBasedIndicator } from "./igr-itemwise-strategy-based-indicator";
import { MedianPriceIndicator } from "./MedianPriceIndicator";
/**
 * Represents a IgxDataChartComponent Median Price indicator series.
 * Default required members: High, Low
*
* Represents a Ignite UIDataChart Median Price indicator series.
*
* Example:
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrMedianPriceIndicator
* 	name="series1"
* 	volumeMemberPath="Volume"
* 	highMemberPath="High"
* 	lowMemberPath="Low"/>
*  </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrMedianPriceIndicator({ name: "Series1" });
* this.series.dataSource = this.data;
* this.series.xAxis = this.categoryXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.volumeMemberPath="Volume" ;
* this.series.highMemberPath="High";
* this.series.lowMemberPath="Low";
* ```
*/
var IgrMedianPriceIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(IgrMedianPriceIndicator, _super);
    function IgrMedianPriceIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrMedianPriceIndicator.prototype.createImplementation = function () {
        return new MedianPriceIndicator();
    };
    Object.defineProperty(IgrMedianPriceIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrMedianPriceIndicator;
}(IgrItemwiseStrategyBasedIndicator));
export { IgrMedianPriceIndicator };
//# sourceMappingURL=igr-median-price-indicator.js.map
