import { Type } from "igniteui-react-core";
/**
 * Describes available positions of labels.
 */
export declare enum LabelsPosition {
    /**
     * No labels will be displayed.
     */
    None = 0,
    /**
     * Labels will be displayed in the center.
     */
    Center = 1,
    /**
     * Labels will be displayed inside and by the edge of the container.
     */
    InsideEnd = 2,
    /**
     * Labels will be displayed outside the container.
     */
    OutsideEnd = 3,
    /**
     * Labels will automatically decide their location.
     */
    BestFit = 4
}
/**
 * @hidden
 */
export declare let LabelsPosition_$type: Type;
