import { IgrAnnotationLayer, IIgrAnnotationLayerProps } from "./igr-annotation-layer";
import { CategoryToolTipLayer } from "./CategoryToolTipLayer";
/**
 * Represents an annotation layer that displays grouped tooltips for series that use a category axis.
*/
export declare class IgrCategoryToolTipLayer extends IgrAnnotationLayer<IIgrCategoryToolTipLayerProps> {
    protected createImplementation(): CategoryToolTipLayer;
    /**
                                 * @hidden
                                 */
    readonly i: CategoryToolTipLayer;
    constructor(props: IIgrCategoryToolTipLayerProps);
    /**
     * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
    */
    readonly isDefaultTooltipBehaviorDisabled: boolean;
    /**
     * Gets or sets whether to use value interpolation when drawing the tooltips.
    */
    useInterpolation: boolean;
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    hideToolTips(): void;
}
export interface IIgrCategoryToolTipLayerProps extends IIgrAnnotationLayerProps {
    /**
     * Gets or sets whether to use value interpolation when drawing the tooltips.
    */
    useInterpolation?: boolean | string;
}
