import { BrushSelectionMode } from "./BrushSelectionMode";
import { IgrBrushScale, IIgrBrushScaleProps } from "./igr-brush-scale";
import { CustomPaletteBrushScale } from "./CustomPaletteBrushScale";
/**
 * Represents a brush scale that uses index-based brush selection mode.
*/
export declare class IgrCustomPaletteBrushScale extends IgrBrushScale<IIgrCustomPaletteBrushScaleProps> {
    protected createImplementation(): CustomPaletteBrushScale;
    /**
                                 * @hidden
                                 */
    readonly i: CustomPaletteBrushScale;
    constructor(props: IIgrCustomPaletteBrushScaleProps);
    /**
     * Gets or sets the brush selection mode.
    */
    brushSelectionMode: BrushSelectionMode;
    /**
     * Checks if this scale is ready for useage with a series
    */
    readonly isReady: boolean;
    getBrush1(index: number, total: number): string;
}
export interface IIgrCustomPaletteBrushScaleProps extends IIgrBrushScaleProps {
    /**
     * Gets or sets the brush selection mode.
    */
    brushSelectionMode?: BrushSelectionMode | string;
}
