import { IgrAnchoredRadialSeries, IIgrAnchoredRadialSeriesProps } from "./igr-anchored-radial-series";
import { RadialPieSeries } from "./RadialPieSeries";
/**
 * Represents a IgxDataChartComponent radial pie series.
 * Compare values across categories by using radial pie slices.
*/
export declare class IgrRadialPieSeries extends IgrAnchoredRadialSeries<IIgrRadialPieSeriesProps> {
    protected createImplementation(): RadialPieSeries;
    /**
                                 * @hidden
                                 */
    readonly i: RadialPieSeries;
    constructor(props: IIgrRadialPieSeriesProps);
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    radiusX: number;
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    radiusY: number;
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan(): number;
}
export interface IIgrRadialPieSeriesProps extends IIgrAnchoredRadialSeriesProps {
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    radiusX?: number | string;
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    radiusY?: number | string;
}
